<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

/**
* Content Slider by M.Majunke
*
* @version 1.6.1_j16
* @package PLG_CONTENT_SLIDER
* @copyright Copyright (C) 2011 Majunke Michael. All rights reserved.
* @license GNU/GPL
*/

// Import library dependencies
jimport('joomla.plugin.plugin');

/**
* <h1>Slider Plugin</h1>
* <br/>
* Used JavaScript with Mootools Lib
* <br/>
*
* <b>Plugin Parameter:</b><br/>
* csspath: optional Path where to search th slider.css File ( Default in Plugin Dir )<br/>
* closeDepMode: closeDep="*" works uique in an Article or Overall<br/>
*
* <b>Usage:</b>
* <code><slider id="x" title="The page title" direction="0|1" {active="1"} {cssSuffix="suffix"} {desc="title desc not hidden"} {closeDep="id;id;..."} {duration="Milliseconds"} /></code>
*
* Must : id        => an unique ID on Page ( example 1 )
* Must : title     => Slider title ( example Testtitle )
* Must : direction => 0 means vertical / 1 means horizontal Slider
* Opt  : active    => 1 means Active per Default. Delete Paramter if not Active per Default.
* Opt  : cssSuffix => is appended to normal cssClasses ( example _mySuffix )
* Opt  : desc      => Description to Slider is allways show similrry the title field ( example TestDescription )
* Opt  : closeDep  => Semik (;) separted List of id's from Sliders that should be closed OR '*' ( example on a slider with id 3 : 1;2 )
* Opt  : duration  => Duration slideIn/Out in MilliSeconds ( Default: 500 )
*/
class plgContentSlider extends JPlugin {

    /* Group [0] = Match ; [1] = key=value ; [2] = key ; [3] = value ... */
    // /sU ungierig , da .*? direkt nicht geht
    // const PATTERN = '/[\{]{1}slider(\s+(id)="([^"]+)"){1}(\s+(title)="([^"]+)"){1}(\s+(direction)="([^"]+)"){1}(\s+(cssSuffix)="([^"]+)")?([\}]{1})(.*)([\{]{1}sliderEnd[\}]{1})/sU';
    const PATTERN = '/[\{]{1}slider(\s+(id)="([^"]+)"){1}(\s+(title)="([^"]+)"){1}(\s+(direction)="([^"]+)"){1}(\s+(active)="([^"]+)")?(\s+(cssSuffix)="([^"]+)")?(\s+(desc)="([^"]+)")?(\s+(closeDep)="([^"]+)")?(\s+(duration)="([^"]+)")?([\}]{1})(.*)([\{]{1}sliderEnd[\}]{1})/sU';

    /**
     *
     */
    function plgContentSlider(&$subject, $config)
    {
        parent::__construct($subject, $config);
    }

    /**
     *
     */
    function onContentPrepare(  $context, &$article, &$params , $limitstart )
    {
        // Search Plugins in Articel
        $matches = array();
        $se = preg_match_all(plgContentSlider::PATTERN, $article->text, $matches);

        // Found Instances of Plugin ?
        if ($se === false) {
            JError::raiseWarning (1, JText::_('Problem while Parsing Document in ContentSliderPlugin.'));
            return false;
        }
        else  if ( empty($se) ) {
        	return true;
        }
        else {

            // Set Values from Config
            $document = &JFactory::getDocument();

            // Params
            $csspath = $this->params->def('csspath', '');
            $closeDepMode = $this->params->def('closeDepMode', 'article');

            if (!empty($csspath)) {
                // need . DS . ?
                $document->addStyleSheet(
                    JURI::base() . $csspath . "/slider.css",
                    'text/css',
                    null,
                    array());
            } else {
                // need . DS . ?
                $document->addStyleSheet(
                    JURI::base() . 'plugins/content/slider/slider.css',
                    'text/css',
                    null,
                    array());
            }

            //
            $document->addScript(JURI::base() . 'plugins/content/slider/slider.js');

            // Add Additionals
            // need mootools
            $document->addScriptDeclaration(JHTML::_('behavior.mootools'));

            // adds a window.Event and init a Slider Array
            // the Array ist an Two-Dim Arr [x][0] = a mySlideX Object [x][1] = the slideId

			$js_s = "window.addEvent( 'domready', function() {" ;
			if ( $closeDepMode === 'article' ){

	            $js_s = $js_s . "  var simpleSliderArr = new Array( 0 ); " ;
			}
			else {

	            $js_s = $js_s .
						"   if ( typeof simpleSliderArr == 'undefined' || simpleSliderArr == null ) { " .
						"     simpleSliderArr = new Array( 0 ); " .
						"   } ";

			}

            $document->addScriptDeclaration( $js_s );

            // Doing for each slidertext
            $this->_process($article, $matches, $se);

            // close window.addEvent
            $document->addScriptDeclaration( "}); " );

            return true;
        }

    }

    /**
    * The proccessing function
    */
    protected function _process(&$article, &$matches, $count)
    {
        for ($i = 0; $i < $count; $i++) {

            // Groups from RegExp
            $plg = $matches[0][$i]; // Plugin
            $id = $matches[3][$i]; // IDs
            $title = $matches[6][$i]; // Titles
            $direction = $matches[9][$i]; // Dir
            $active = $matches[12][$i]; // Active
            $cssSuffix = $matches[15][$i]; // CSS
            $desc = $matches[18][$i]; // DESC
            $closeDep = $matches[21][$i]; // Closing Auto closeDep
            $duration = $matches[24][$i]; // Duration
            $val = $matches[26][$i]; // Text

            // Render direction
            $modeValue = '';
            if ($direction == 1) {
                $modeValue = ", {mode: 'horizontal'}";
            }

            // Duration
            $durationRep = '500';
            if ( !empty($duration) ) {
              $durationRep = $duration;
            }

			// Render active per Default
			$activeRepl = '';
  		    if ( $active == '1' ) {
			      $activeRepl = "  toogle$id(null); " ;
		    }

            // Render Description div
            $descRepl = '';
            if ( !empty($desc) ) {
            	$descRepl = '<div id="slideDesc' . $id . '" class="slideDesc' . $cssSuffix . '">' . $desc . '</div>' ;
            }

            // Render JS to close other sliders .. closeDepend
            $closeDepRepl = '';
            if ( !empty($closeDep) ) {
            	if ( 0 != strcmp( "*" , $closeDep ) ) {
                // render close for each sliderid
                $arr_ids = explode( ";", $closeDep );
        				for ( $ai=0; $ai < count($arr_ids) ; $ai++){
        					if ( !empty($arr_ids[$ai])) {
        						$closeDepRepl = $closeDepRepl .
                                    'closeSlider(  mySlide' . trim( $arr_ids[$ai] ) . ', "' . trim( $arr_ids[$ai] ) . '" );' ;
          				}
        	   		}
      	   		}
      	   		else {
                	$closeDepRepl = 'closeSlidersAllInWithoutX( simpleSliderArr , mySlide' . $id . ');' ;
               }
            }

            // Slider Container
            $replaceText = '<a id="toggleSlide' . $id . '" name="toggleSlide' . $id . '" class="slideBar' . $cssSuffix . '">' . $title . '</a>' .
			                     $descRepl .
						               '<div id="slide' . $id . '" class="slideText' . $cssSuffix . '">' . $val . '</div>' .
						               '<a id="toggleSlideEnd' . $id . '" name="toggleSlideEnd' . $id . '" class="slideBarEnd' . $cssSuffix . '">' . $title . '</a>' ;

            // Replace Line
            $article->text = str_replace($plg, $replaceText, $article->text);

			      // Adding the Script for each Plugin
            $script =
            // avoid js err in Pagebreak
            "if ( document.getElementById( 'slide" . $id . "') != null ) { " .
            // init slide
	          // "  mySlide" . $id . " = new Fx.Slide('slide" . $id . "' " . $modeValue . "); " .
	          "  mySlide" . $id . " = new Fx.Slide('slide" . $id . "' " . $modeValue . "  , {duration: " . $durationRep . "} ); " .
            // register Slider
            'sarr = new Array(2);' .
            'sarr[0] = "'. $id . '";' .
            'sarr[1] = mySlide' . $id . ';' .
            'simpleSliderArr.push( sarr ) ;' .
					  "  mySlide" . $id . ".hide(); " .
					  "  function toogle" . $id . "( e ) { " .
					  '   if ( typeof mySlide' . $id . ' == "undefined" || mySlide' . $id . ' == null ) { return ; } ' .
					  "         flag = mySlide" . $id . ".open ; " .
					  "         if ( ! flag ) {" .
					  "           mySlide" . $id . ".slideIn() ;" . // ';'
            // ".chain(function(){ " .
					  "           document.getElementById( 'toggleSlide" . $id . "').className = 'slideBarActive" . $cssSuffix . "';" .
	          "           if ( document.getElementById( 'slideDesc" . $id . "') != null ) { document.getElementById( 'slideDesc" . $id . "').className = 'slideDescActive" . $cssSuffix . "'; } " .
					  "           if ( document.getElementById( 'slide" . $id . "') != null ) { document.getElementById( 'slide" . $id . "').className = 'slideTextActive" . $cssSuffix . "'; } " .
					  // End-Button
					  "           document.getElementById( 'toggleSlideEnd" . $id . "').className = 'slideBarEndActive" . $cssSuffix . "';" .
					  // "         });" .
            //  closeDepend Sliders
					  "           if ( e != null ){" . // runs only if toogle comes from an event
                          $closeDepRepl .
            "           } ;" .
					  "         } " .
	          "         else {" .
	          "         mySlide" . $id . ".slideOut() ;" . // ';'
            // ".chain(function(){ " .
	          "           document.getElementById( 'toggleSlide" . $id . "').className = 'slideBar" . $cssSuffix . "'; " .
	          "           if ( document.getElementById( 'slideDesc" . $id . "') != null ) { document.getElementById( 'slideDesc" . $id . "').className = 'slideDesc" . $cssSuffix . "'; } " .
	  				"           if ( document.getElementById( 'slide" . $id . "') != null ) { document.getElementById( 'slide" . $id . "').className = 'slideText" . $cssSuffix . "'; } " .
					  // End-Button
					  "           document.getElementById( 'toggleSlideEnd" . $id . "').className = 'slideBarEnd" . $cssSuffix . "';" .
 	          // "         });" .
 	          "         }"  .
					  "     }; " .
					  // Events
					  "  $('toggleSlide" . $id . "').addEvent( 'mousedown', function(e){ e = new Event(e); toogle" . $id . "(e) ; e.stop() ; }  );" .
					  "  $('toggleSlideEnd" . $id . "').addEvent( 'mousedown', function(e){  e = new Event(e); toogle" . $id . "(e)  ; e.stop() ; }  );" .
            // active ?
               $activeRepl .
            // end avoid Pagebreak
            " }; "
            ;

            //  joomla hat aktuell nicht mootools 1.2 ! $('toggleSlide" . $id . "').morph( '.slideBar' ); " .

            // Vars
            $document = &JFactory::getDocument();
            $document->addScriptDeclaration($script);

        }
    }
}